--- /dev/null	Fri Jun 13 16:44:29 2008
+++ new/usr/src/common/crypto/THIRDPARTYLICENSE.cryptogams	Fri Jun 13 16:44:29 2008
@@ -0,0 +1,36 @@
+Copyright (c) 2006, CRYPTOGAMS by <appro@openssl.org>
+All rights reserved.
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions
+are met:
+
+      *	Redistributions of source code must retain copyright notices,
+	this list of conditions and the following disclaimer.
+
+      *	Redistributions in binary form must reproduce the above
+	copyright notice, this list of conditions and the following
+	disclaimer in the documentation and/or other materials
+	provided with the distribution.
+
+      *	Neither the name of the CRYPTOGAMS nor the names of its
+	copyright holder and contributors may be used to endorse or
+	promote products derived from this software without specific
+	prior written permission.
+
+ALTERNATIVELY, provided that this notice is retained in full, this
+product may be distributed under the terms of the GNU General Public
+License (GPL), in which case the provisions of the GPL apply INSTEAD OF
+those given above.
+
+THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS
+"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--- /dev/null	Fri Jun 13 16:44:30 2008
+++ new/usr/src/common/crypto/THIRDPARTYLICENSE.cryptogams.descrip	Fri Jun 13 16:44:30 2008
@@ -0,0 +1,1 @@
+PORTIONS OF ARCFOUR, SHA1, AND SHA2 FUNCTIONALITY
--- old/usr/src/common/crypto/aes/aes_cbc_crypt.c	Fri Jun 13 16:44:31 2008
+++ new/usr/src/common/crypto/aes/aes_cbc_crypt.c	Fri Jun 13 16:44:31 2008
@@ -23,7 +23,7 @@
  * Use is subject to license terms.
  */
 
-#pragma ident	"@(#)aes_cbc_crypt.c	1.9	08/05/09 SMI"
+#pragma ident	"@(#)aes_cbc_crypt.c	1.10	08/06/13 SMI"
 
 
 #include <sys/sysmacros.h>
@@ -50,7 +50,7 @@
 
 /*
  * Initialize by setting iov_or_mp to point to the current iovec or mp,
- * and by setting current_offset to an offset within the current iovec or mp .
+ * and by setting current_offset to an offset within the current iovec or mp.
  */
 static void
 aes_init_ptrs(crypto_data_t *out, void **iov_or_mp, offset_t *current_offset)
@@ -253,8 +253,7 @@
 			 * XOR the previous cipher block or IV with the
 			 * current clear block. Check for alignment.
 			 */
-			if (IS_P2ALIGNED(blockp, sizeof (uint32_t)) &&
-			    IS_P2ALIGNED(lastp, sizeof (uint32_t))) {
+			if (IS_P2ALIGNED2(blockp, lastp, sizeof (uint32_t))) {
 				/* LINTED: pointer alignment */
 				*(uint32_t *)&blockp[0] ^=
 				/* LINTED: pointer alignment */
@@ -294,11 +293,27 @@
 			    &out_data_1_len, &out_data_2, AES_BLOCK_LEN);
 
 			/* copy block to where it belongs */
-			bcopy(lastp, out_data_1, out_data_1_len);
+			if ((out_data_1_len == AES_BLOCK_LEN) &&
+			    (IS_P2ALIGNED2(lastp, out_data_1,
+			    sizeof (uint32_t)))) {
+				/* LINTED: pointer alignment */
+				uint32_t *d = (uint32_t *)out_data_1;
+				/* LINTED: pointer alignment */
+				d[0] = *(uint32_t *)lastp;
+				/* LINTED: pointer alignment */
+				d[1] = *(uint32_t *)&lastp[4];
+				/* LINTED: pointer alignment */
+				d[2] = *(uint32_t *)&lastp[8];
+				/* LINTED: pointer alignment */
+				d[3] = *(uint32_t *)&lastp[12];
+			} else {
+				bcopy(lastp, out_data_1, out_data_1_len);
+			}
 			if (out_data_2 != NULL) {
 				bcopy(lastp + out_data_1_len, out_data_2,
 				    AES_BLOCK_LEN - out_data_1_len);
 			}
+
 			/* update offset */
 			out->cd_offset += AES_BLOCK_LEN;
 		}
@@ -463,8 +478,7 @@
 			 * XOR the previous cipher block or IV with the
 			 * currently decrypted block.  Check for alignment.
 			 */
-			if (IS_P2ALIGNED(blockp, sizeof (uint32_t)) &&
-			    IS_P2ALIGNED(lastp, sizeof (uint32_t))) {
+			if (IS_P2ALIGNED2(blockp, lastp, sizeof (uint32_t))) {
 				/* LINTED: pointer alignment */
 				*(uint32_t *)blockp ^= *(uint32_t *)lastp;
 				/* LINTED: pointer alignment */
@@ -492,7 +506,17 @@
 			    &out_data_1_len, &out_data_2, AES_BLOCK_LEN);
 
 			/* copy temporary block to where it belongs */
-			bcopy(&tmp, out_data_1, out_data_1_len);
+			if ((out_data_1_len == AES_BLOCK_LEN) &&
+			    (IS_P2ALIGNED(out_data_1, sizeof (uint32_t)))) {
+				/* LINTED: pointer alignment */
+				uint32_t *d = (uint32_t *)out_data_1;
+				d[0] = tmp[0];
+				d[1] = tmp[1];
+				d[2] = tmp[2];
+				d[3] = tmp[3];
+			} else {
+				bcopy(&tmp, out_data_1, out_data_1_len);
+			}
 			if (out_data_2 != NULL) {
 				bcopy((uint8_t *)&tmp + out_data_1_len,
 				    out_data_2, AES_BLOCK_LEN - out_data_1_len);
@@ -694,8 +718,7 @@
 			 * XOR the previous cipher block current clear block.
 			 * mac_buf always contain previous cipher block.
 			 */
-			if (IS_P2ALIGNED(blockp, sizeof (uint32_t)) &&
-			    IS_P2ALIGNED(mac_buf, sizeof (uint32_t))) {
+			if (IS_P2ALIGNED2(blockp, mac_buf, sizeof (uint32_t))) {
 				/* LINTED: pointer alignment */
 				*(uint32_t *)&mac_buf[0] ^=
 				/* LINTED: pointer alignment */
@@ -760,8 +783,7 @@
 		 * XOR the previous cipher block or IV with the
 		 * current clear block. Check for alignment.
 		 */
-		if (IS_P2ALIGNED(blockp, sizeof (uint32_t)) &&
-		    IS_P2ALIGNED(lastp, sizeof (uint32_t))) {
+		if (IS_P2ALIGNED2(blockp, lastp, sizeof (uint32_t))) {
 			/* LINTED: pointer alignment */
 			*(uint32_t *)&blockp[0] ^=
 			/* LINTED: pointer alignment */
@@ -800,11 +822,27 @@
 			    &out_data_1_len, &out_data_2, AES_BLOCK_LEN);
 
 			/* copy block to where it belongs */
-			bcopy(lastp, out_data_1, out_data_1_len);
+			if ((out_data_1_len == AES_BLOCK_LEN) &&
+			    (IS_P2ALIGNED2(lastp, out_data_1,
+			    sizeof (uint32_t)))) {
+				/* LINTED: pointer alignment */
+				uint32_t *d = (uint32_t *)out_data_1;
+				/* LINTED: pointer alignment */
+				d[0] = *(uint32_t *)lastp;
+				/* LINTED: pointer alignment */
+				d[1] = *(uint32_t *)&lastp[4];
+				/* LINTED: pointer alignment */
+				d[2] = *(uint32_t *)&lastp[8];
+				/* LINTED: pointer alignment */
+				d[3] = *(uint32_t *)&lastp[12];
+			} else {
+				bcopy(lastp, out_data_1, out_data_1_len);
+			}
 			if (out_data_2 != NULL) {
 				bcopy(lastp + out_data_1_len, out_data_2,
 				    AES_BLOCK_LEN - out_data_1_len);
 			}
+
 			/* update offset */
 			out->cd_offset += AES_BLOCK_LEN;
 		}
@@ -868,8 +906,7 @@
 	bzero(iv, AES_BLOCK_LEN);
 	ivp = (uint8_t *)iv;
 
-	if (IS_P2ALIGNED(ivp, sizeof (uint32_t)) &&
-	    IS_P2ALIGNED(mac_buf, sizeof (uint32_t))) {
+	if (IS_P2ALIGNED2(ivp, mac_buf, sizeof (uint32_t))) {
 		/* LINTED: pointer alignment */
 		*(uint32_t *)&mac_buf[0] ^= *(uint32_t *)&ivp[0];
 		/* LINTED: pointer alignment */
@@ -905,8 +942,7 @@
 	}
 	bcopy(auth_data, authp+encoded_a_len, processed);
 	/* xor with previous buffer */
-	if (IS_P2ALIGNED(authp, sizeof (uint32_t)) &&
-	    IS_P2ALIGNED(mac_buf, sizeof (uint32_t))) {
+	if (IS_P2ALIGNED2(authp, mac_buf, sizeof (uint32_t))) {
 		/* LINTED: pointer alignment */
 		*(uint32_t *)&mac_buf[0] ^= *(uint32_t *)&authp[0];
 		/* LINTED: pointer alignment */
@@ -942,8 +978,7 @@
 		}
 
 		/* xor with previous buffer */
-		if (IS_P2ALIGNED(datap, sizeof (uint32_t)) &&
-		    IS_P2ALIGNED(mac_buf, sizeof (uint32_t))) {
+		if (IS_P2ALIGNED2(datap, mac_buf, sizeof (uint32_t))) {
 			/* LINTED: pointer alignment */
 			*(uint32_t *)&mac_buf[0] ^= *(uint32_t *)&datap[0];
 			/* LINTED: pointer alignment */
@@ -1034,8 +1069,7 @@
 		bcopy(ctx->ac_remainder, macp, ctx->ac_remainder_len);
 
 		/* calculate the CBC MAC */
-		if (IS_P2ALIGNED(macp, sizeof (uint32_t)) &&
-		    IS_P2ALIGNED(mac_buf, sizeof (uint32_t))) {
+		if (IS_P2ALIGNED2(macp, mac_buf, sizeof (uint32_t))) {
 			/* LINTED: pointer alignment */
 			*(uint32_t *)&mac_buf[0] ^= *(uint32_t *)&macp[0];
 			/* LINTED: pointer alignment */
@@ -1147,7 +1181,7 @@
 	uint64_t maxValue;
 
 	/*
-	 * Check the length of the MAC.  Only valid length
+	 * Check the byte length of the MAC.  The only valid
 	 * lengths for the MAC are: 4, 6, 8, 10, 12, 14, 16
 	 */
 	macSize = ccm_param->ulMACSize;
@@ -1155,12 +1189,13 @@
 		return (CRYPTO_MECHANISM_PARAM_INVALID);
 	}
 
-	/* Check the nonce value.  Valid values are 7, 8, 9, 10, 11, 12, 13 */
+	/* Check the nonce length.  Valid values are 7, 8, 9, 10, 11, 12, 13 */
 	nonceSize = ccm_param->ulNonceSize;
 	if ((nonceSize < 7) || (nonceSize > 13)) {
 		return (CRYPTO_MECHANISM_PARAM_INVALID);
 	}
 
+	/* q is the length of the field storing the length, in bytes */
 	q = (uint8_t)((15 - nonceSize) & 0xFF);
 
 
@@ -1177,7 +1212,7 @@
 	 * range of values allowed by q
 	 */
 	if (q < 8) {
-		maxValue = 1ULL << (q * 8);
+		maxValue = (1ULL << (q * 8)) - 1;
 	} else {
 		maxValue = ULONG_MAX;
 	}
@@ -1192,7 +1227,7 @@
 
 /*
  * Format the first block used in CBC-MAC (B0) and the initial counter
- * block based on formating functions and counter generation functions
+ * block based on formatting functions and counter generation functions
  * specified in RFC 3610 and NIST publication 800-38C, appendix A
  *
  * b0 is the first block used in CBC-MAC
@@ -1219,7 +1254,7 @@
 	q = (uint8_t)((15 - nonceSize) & 0xFF);
 	t = (uint8_t)((aes_ctx->ac_ccm_mac_len) & 0xFF);
 
-	/* Construct the first octect of b0 */
+	/* Construct the first octet of b0 */
 	if (authDataSize > 0) {
 		have_adata = 1;
 	}
@@ -1272,7 +1307,7 @@
 	 * During calculation, we start using counter block 1, we will
 	 * set it up right here.
 	 * We can just set the last byte to have the value 1, because
-	 * even with the bigest nonce of 13, the last byte of the
+	 * even with the biggest nonce of 13, the last byte of the
 	 * counter block will be used for the counter value.
 	 */
 	cb[15] = 0x01;
@@ -1525,8 +1560,7 @@
 		    (ctx->ac_cb[1] & ~(ctx->ac_counter_mask)) | counter;
 
 		/* XOR with the ciphertext */
-		if (IS_P2ALIGNED(blockp, sizeof (uint32_t)) &&
-		    IS_P2ALIGNED(cbp, sizeof (uint32_t))) {
+		if (IS_P2ALIGNED2(blockp, cbp, sizeof (uint32_t))) {
 			/* LINTED: pointer alignment */
 			*(uint32_t *)&blockp[0] ^= *(uint32_t *)&cbp[0];
 			/* LINTED: pointer alignment */
@@ -1542,8 +1576,7 @@
 		/* Copy the plaintext to the "holding buffer" */
 		resultp = (uint8_t *)ctx->ac_ccm_pt_buf +
 		    ctx->ac_ccm_processed_data_len;
-		if (IS_P2ALIGNED(blockp, sizeof (uint32_t)) &&
-		    IS_P2ALIGNED(resultp, sizeof (uint32_t))) {
+		if (IS_P2ALIGNED2(blockp, resultp, sizeof (uint32_t))) {
 			/* LINTED: pointer alignment */
 			*(uint32_t *)&resultp[0] = *(uint32_t *)blockp;
 			/* LINTED: pointer alignment */
@@ -1629,8 +1662,7 @@
 			bcopy(pt, tmp, mac_remain);
 			mac_remain = 0;
 		} else {
-			if (IS_P2ALIGNED(pt, sizeof (uint32_t)) &&
-			    IS_P2ALIGNED(macp, sizeof (uint32_t))) {
+			if (IS_P2ALIGNED2(pt, macp, sizeof (uint32_t))) {
 				/* LINTED: pointer alignment */
 				*(uint32_t *)&macp[0] = *(uint32_t *)pt;
 				/* LINTED: pointer alignment */
@@ -1647,8 +1679,7 @@
 		}
 
 		/* calculate the CBC MAC */
-		if (IS_P2ALIGNED(macp, sizeof (uint32_t)) &&
-		    IS_P2ALIGNED(mac_buf, sizeof (uint32_t))) {
+		if (IS_P2ALIGNED2(macp, mac_buf, sizeof (uint32_t))) {
 			/* LINTED: pointer alignment */
 			*(uint32_t *)&mac_buf[0] ^= *(uint32_t *)&macp[0];
 			/* LINTED: pointer alignment */
--- old/usr/src/common/crypto/aes/aes_cbc_crypt.h	Fri Jun 13 16:44:34 2008
+++ new/usr/src/common/crypto/aes/aes_cbc_crypt.h	Fri Jun 13 16:44:33 2008
@@ -19,7 +19,7 @@
  * CDDL HEADER END
  */
 /*
- * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
+ * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
 
@@ -26,7 +26,7 @@
 #ifndef	_AES_CBC_CRYPT_H
 #define	_AES_CBC_CRYPT_H
 
-#pragma ident	"@(#)aes_cbc_crypt.h	1.6	07/09/11 SMI"
+#pragma ident	"@(#)aes_cbc_crypt.h	1.7	08/05/21 SMI"
 
 #ifdef	__cplusplus
 extern "C" {
@@ -72,7 +72,7 @@
  *			length of the ciphertext for CCM mode decrypt.
  * ac_ccm_processed_data_len:
  *			Length of processed plaintext in CCM mode encrypt,
- *			or length of processed ciphertex for CCM mode decrypt.
+ *			or length of processed ciphertext for CCM mode decrypt.
  * ac_ccm_processed_mac_len:
  *			Length of MAC data accumulated in CCM mode decrypt.
  *
--- old/usr/src/common/crypto/aes/aes_impl.c	Fri Jun 13 16:44:36 2008
+++ new/usr/src/common/crypto/aes/aes_impl.c	Fri Jun 13 16:44:36 2008
@@ -2,9 +2,8 @@
  * CDDL HEADER START
  *
  * The contents of this file are subject to the terms of the
- * Common Development and Distribution License, Version 1.0 only
- * (the "License").  You may not use this file except in compliance
- * with the License.
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
  *
  * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
  * or http://www.opensolaris.org/os/licensing.
@@ -20,10 +19,12 @@
  * CDDL HEADER END
  */
 /*
- * Copyright 2003 Sun Microsystems, Inc.  All rights reserved.
+ * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
 
+#pragma ident	"@(#)aes_impl.c	1.3	08/06/12 SMI"
+
 #include <sys/types.h>
 #include <sys/systm.h>
 #include <sys/ddi.h>
@@ -36,13 +37,12 @@
 #include <stdlib.h>
 #endif	/* !_KERNEL */
 
-#pragma ident	"@(#)aes_impl.c	1.2	05/06/08 SMI"
 
 /*
  * This file is derived from the file  rijndael-alg-fst.c  taken from the
  * "optimized C code v3.0" on the "rijndael home page"
- * (http://www.esat.kuleuven.ac.be/~rijmen/rijndael/)
- * pointed by the NIST web-site (http://nist.gov)
+ * http://www.iaik.tu-graz.ac.at/research/krypto/AES/old/~rijmen/rijndael/
+ * pointed by the NIST web-site http://csrc.nist.gov/archive/aes/
  *
  * The following note is from the original file:
  */
@@ -75,9 +75,33 @@
 
 /* EXPORT DELETE START */
 
-#ifndef _RIJNDAEL_TBL_H
-#define	_RIJNDAEL_TBL_H
+#if defined(sun4u) || defined(__amd64)
+/* External assembly functions: */
+extern void aes_encrypt_impl(const uint32_t rk[], int Nr, const uint32_t pt[4],
+	uint32_t ct[4]);
+extern void aes_decrypt_impl(const uint32_t rk[], int Nr, const uint32_t ct[4],
+	uint32_t pt[4]);
+#define	AES_ENCRYPT_IMPL		aes_encrypt_impl
+#define	AES_DECRYPT_IMPL		aes_decrypt_impl
 
+#ifdef	__amd64
+extern int rijndael_key_setup_enc(uint32_t rk[], const uint32_t cipherKey[],
+	int keyBits);
+extern int rijndael_key_setup_dec(uint32_t rk[], const uint32_t cipherKey[],
+	int keyBits);
+#endif
+
+#else
+#define	AES_ENCRYPT_IMPL		rijndael_encrypt
+#define	AES_DECRYPT_IMPL		rijndael_decrypt
+#define	rijndael_key_setup_enc_raw	rijndael_key_setup_enc
+#endif	/* sun4u || __amd64 */
+
+#if defined(_LITTLE_ENDIAN) && !defined(__amd64)
+#define	AES_BYTE_SWAP
+#endif
+
+#ifndef	__amd64
 /*
  *  Constant tables
  */
@@ -96,6 +120,7 @@
  * Td4[x] = Si[x].[01, 01, 01, 01];
  */
 
+/* Encrypt Sbox constants (for the substitute bytes operation) */
 
 static const uint32_t Te0[256] =
 {
@@ -440,6 +465,8 @@
 	0xb0b0b0b0U, 0x54545454U, 0xbbbbbbbbU, 0x16161616U
 };
 
+/* Decrypt Sbox constants (for the substitute bytes operation) */
+
 static const uint32_t Td0[256] =
 {
 	0x51f4a750U, 0x7e416553U, 0x1a17a4c3U, 0x3a275e96U,
@@ -781,7 +808,8 @@
 	0x55555555U, 0x21212121U, 0x0c0c0c0cU, 0x7d7d7d7dU
 };
 
-static const uint32_t rcon[] =
+/* Rcon is Round Constant; used for encryption key expansion */
+static const uint32_t rcon[RC_LENGTH] =
 {
 	/* for 128-bit blocks, Rijndael never uses more than 10 rcon values */
 	0x01000000, 0x02000000, 0x04000000, 0x08000000,
@@ -788,13 +816,19 @@
 	0x10000000, 0x20000000, 0x40000000, 0x80000000,
 	0x1B000000, 0x36000000
 };
-#endif
 
+
 /*
- *  Expand the cipher key into the encryption key schedule.
- *  return  the number of rounds for the given cipher key size.
- *  The size of the key schedule depends on the number of rounds
- *  (which can be computed from the size of the key), i.e. 4*(Nr + 1).
+ * Expand the cipher key into the encryption key schedule.
+ *
+ * Return the number of rounds for the given cipher key size.
+ * The size of the key schedule depends on the number of rounds
+ * (which can be computed from the size of the key), i.e. 4*(Nr + 1).
+ *
+ * Parameters:
+ * rk		AES key schedule 32-bit array to be initialized
+ * cipherKey	User key
+ * keyBits	AES key size (128, 192, or 256 bits)
  */
 static int
 rijndael_key_setup_enc_raw(uint32_t rk[], const uint32_t cipherKey[],
@@ -889,16 +923,23 @@
 
 	return (0);
 }
+#endif	/* !__amd64 */
 
 
-#ifdef sun4u
+#ifdef	sun4u
 
 /*
- *  Expand the cipher key into the enryption key schedule as used
- *  by the sun4u optimized assembly implementation.
- *  return  the number of rounds for the given cipher key size.
- *  The size of the key schedule depends on the number of rounds
- *  (which can be computed from the size of the key), i.e. 4*(Nr + 1).
+ * Expand the cipher key into the encryption key schedule.
+ * by the sun4u optimized assembly implementation.
+ *
+ * Return the number of rounds for the given cipher key size.
+ * The size of the key schedule depends on the number of rounds
+ * (which can be computed from the size of the key), i.e. 4*(Nr + 1).
+ *
+ * Parameters:
+ * rk		AES key schedule 64-bit array to be initialized
+ * cipherKey	User key
+ * keyBits	AES key size (128, 192, or 256 bits)
  */
 static int
 rijndael_key_setup_enc(uint64_t rk[], const uint32_t cipherKey[], int keyBits)
@@ -929,11 +970,17 @@
 
 
 /*
- *  Expand the cipher key into the decryption key schedule as used
- *  by the sun4u optimized assembly implementation.
- *  return  the number of rounds for the given cipher key size.
- *  The size of the key schedule depends on the number of rounds
- *  (which can be computed from the size of the key), i.e. 4*(Nr + 1).
+ * Expand the cipher key into the decryption key schedule as used
+ * by the sun4u optimized assembly implementation.
+ *
+ * Return the number of rounds for the given cipher key size.
+ * The size of the key schedule depends on the number of rounds
+ * (which can be computed from the size of the key), i.e. 4*(Nr + 1).
+ *
+ * Parameters:
+ * rk		AES key schedule 32-bit array to be initialized
+ * cipherKey	User key
+ * keyBits	AES key size (128, 192, or 256 bits)
  */
 static int
 rijndael_key_setup_dec_raw(uint32_t rk[], const uint32_t cipherKey[],
@@ -982,10 +1029,15 @@
 
 
 /*
- *  The size of the key schedule depends on the number of rounds
- *  (which can be computed from the size of the key), i.e. 4*(Nr + 1).
+ * The size of the key schedule depends on the number of rounds
+ * (which can be computed from the size of the key), i.e. 4*(Nr + 1).
+ *
+ * Parameters:
+ * rk		AES key schedule 64-bit array to be initialized
+ * cipherKey	User key
+ * keyBits	AES key size (128, 192, or 256 bits)
  */
-int
+static int
 rijndael_key_setup_dec(uint64_t rk[], const uint32_t cipherKey[], int keyBits)
 {
 	uint32_t	rk1[4 * (MAX_AES_NR + 1)];
@@ -1012,8 +1064,17 @@
 }
 
 
+/*
+ * Expand the 64-bit AES cipher key array into the encryption and decryption
+ * key schedules.
+ *
+ * Parameters:
+ * key		AES key schedule to be initialized
+ * keyarr32	User key
+ * keyBits	AES key size (128, 192, or 256 bits)
+ */
 static void
-aes_setupkeys(aes_key_t *key, uint32_t *keyarr32, int keybits)
+aes_setupkeys(aes_key_t *key, const uint32_t *keyarr32, int keybits)
 {
 	key->nr = rijndael_key_setup_enc(&(key->encr_ks.ks64[0]), keyarr32,
 	    keybits);
@@ -1022,26 +1083,19 @@
 	key->type = AES_64BIT_KS;
 }
 
-#else /* !sun4u */
 
-/*
- *  Expand the cipher key into the encryption key schedule.
- *  return  the number of rounds for the given cipher key size.
- *  The size of the key schedule depends on the number of rounds
- *  (which can be computed from the size of the key), i.e. 4*(Nr + 1).
- */
-static int
-rijndael_key_setup_enc(uint32_t rk[], const uint32_t cipherKey[], int keyBits)
-{
-	return (rijndael_key_setup_enc_raw(rk, cipherKey, keyBits));
-}
+#elif !defined(__amd64)
 
-
 /*
  *  Expand the cipher key into the decryption key schedule.
- *  @return  the number of rounds for the given cipher key size.
+ *  Return the number of rounds for the given cipher key size.
  *  The size of the key schedule depends on the number of rounds
  *  (which can be computed from the size of the key), i.e. 4*(Nr + 1).
+ *
+ * Parameters:
+ * rk		AES key schedule 32-bit array to be initialized
+ * cipherKey	User key
+ * keyBits	AES key size (128, 192, or 256 bits)
  */
 static int
 rijndael_key_setup_dec(uint32_t rk[], const uint32_t cipherKey[], int keyBits)
@@ -1096,16 +1150,6 @@
 }
 
 
-static void
-aes_setupkeys(aes_key_t *key, uint32_t *keyarr32, int keybits)
-{
-	key->nr = rijndael_key_setup_enc(&(key->encr_ks.ks32[0]), keyarr32,
-	    keybits);
-	key->nr = rijndael_key_setup_dec(&(key->decr_ks.ks32[0]), keyarr32,
-	    keybits);
-	key->type = AES_32BIT_KS;
-}
-
 /*
  * Encrypt one block of data. The block is assumed to be an array
  * of four uint32_t values, so copy for alignment (and byte-order
@@ -1113,8 +1157,14 @@
  * input and output byte streams.
  * The size of the key schedule depends on the number of rounds
  * (which can be computed from the size of the key), i.e. 4*(Nr + 1).
+ *
+ * Parameters:
+ * rk	Key schedule, of aes_ks_t (60 32-bit integers)
+ * Nr	Number of rounds
+ * pt	Input block (plain text)
+ * ct	Output block (crypto text).  Can overlap with pt
  */
-void
+static void
 rijndael_encrypt(const uint32_t rk[], int Nr, const uint32_t pt[4],
     uint32_t ct[4])
 {
@@ -1235,8 +1285,14 @@
  * input and output byte streams.
  * The size of the key schedule depends on the number of rounds
  * (which can be computed from the size of the key), i.e. 4*(Nr + 1).
+ *
+ * Parameters:
+ * rk	Key schedule, of aes_ks_t (60 32-bit integers)
+ * Nr	Number of rounds
+ * ct	Input block (crypto text)
+ * pt	Output block (plain text). Can overlap with pt
  */
-void
+static void
 rijndael_decrypt(const uint32_t rk[], int Nr, const uint32_t ct[4],
     uint32_t pt[4])
 {
@@ -1347,36 +1403,50 @@
 	    rk[3];
 	pt[3] = s3;
 }
+#endif	/* sun4u, !__amd64 */
 
-void
-aes_encrypt_impl(const aes_ks_t *ks, int Nr, const uint32_t pt[4],
-    uint32_t ct[4])
+#ifndef	sun4u
+/*
+ * Expand the 32-bit AES cipher key array into the encryption and decryption
+ * key schedules.
+ *
+ * Parameters:
+ * key		AES key schedule to be initialized
+ * keyarr32	User key
+ * keyBits	AES key size (128, 192, or 256 bits)
+ */
+static void
+aes_setupkeys(aes_key_t *key, const uint32_t *keyarr32, int keybits)
 {
-	rijndael_encrypt(&(ks->ks32[0]), Nr, pt, ct);
+	key->nr = rijndael_key_setup_enc(&(key->encr_ks.ks32[0]), keyarr32,
+	    keybits);
+	key->nr = rijndael_key_setup_dec(&(key->decr_ks.ks32[0]), keyarr32,
+	    keybits);
+	key->type = AES_32BIT_KS;
 }
-
-void
-aes_decrypt_impl(const aes_ks_t *ks, int Nr, const uint32_t ct[4],
-    uint32_t pt[4])
-{
-	rijndael_decrypt(&(ks->ks32[0]), Nr, ct, pt);
-}
-
-#endif /* sun4u */
+#endif	/* sun4u */
 /* EXPORT DELETE END */
 
 
 /*
  * Initialize key schedules for AES
+ *
+ * Parameters:
+ * cipherKey	User key
+ * keyBits	AES key size (128, 192, or 256 bits)
+ * keysched	AES key schedule to be initialized, of type aes_key_t.
+ *		Allocated by aes_alloc_keysched().
  */
 void
-aes_init_keysched(uint8_t *cipherKey, uint_t keyBits, void *keysched)
+aes_init_keysched(const uint8_t *cipherKey, uint_t keyBits, void *keysched)
 {
 /* EXPORT DELETE START */
-	aes_key_t *newbie = keysched;
-	uint64_t keyarr64[4];
-	uint32_t *keyarr32 = (uint32_t *)keyarr64;
-	uint_t keysize, i, j;
+	aes_key_t	*newbie = keysched;
+	uint_t		keysize, i, j;
+	union {
+		uint64_t	ka64[4];
+		uint32_t	ka32[8];
+		} keyarr;
 
 	switch (keyBits) {
 	case 128:
@@ -1398,65 +1468,87 @@
 	keysize = keyBits >> 3;
 
 	/*
-	 * The code below, that is always executed on LITTLE_ENDIAN machines,
-	 * reverses every 4 bytes in the key.  On BIG_ENDIAN, the same code
-	 * copies the key without reversing bytes.
+	 * For _LITTLE_ENDIAN machines (except AMD64), reverse every
+	 * 4 bytes in the key.  On _BIG_ENDIAN and AMD64, copy the key
+	 * without reversing bytes.
+	 * For AMD64, do not byte swap for aes_setupkeys().
+	 *
+	 * SPARCv8/v9 uses a key schedule array with 64-bit elements.
+	 * X86/AMD64  uses a key schedule array with 32-bit elements.
 	 */
-#ifdef _BIG_ENDIAN
+#ifndef	AES_BYTE_SWAP
 	if (IS_P2ALIGNED(cipherKey, sizeof (uint64_t))) {
 		for (i = 0, j = 0; j < keysize; i++, j += 8) {
 			/* LINTED: pointer alignment */
-			keyarr64[i] = *((uint64_t *)&cipherKey[j]);
+			keyarr.ka64[i] = *((uint64_t *)&cipherKey[j]);
 		}
 	} else {
-#endif
-		for (i = 0, j = 0; j < keysize; i++, j += 4) {
-			keyarr32[i] = (((uint32_t)cipherKey[j] << 24) |
-			    ((uint32_t)cipherKey[j + 1] << 16) |
-			    ((uint32_t)cipherKey[j + 2] << 8) |
-			    (uint32_t)cipherKey[j + 3]);
-		}
-#ifdef _BIG_ENDIAN
+		bcopy(cipherKey, keyarr.ka32, keysize);
 	}
+
+#else	/* byte swap */
+	for (i = 0, j = 0; j < keysize; i++, j += 4) {
+		keyarr.ka32[i] = (((uint32_t)cipherKey[j] << 24) |
+		    ((uint32_t)cipherKey[j + 1] << 16) |
+		    ((uint32_t)cipherKey[j + 2] << 8) |
+		    (uint32_t)cipherKey[j + 3]);
+	}
 #endif
-	aes_setupkeys(newbie, keyarr32, keyBits);
 
+	aes_setupkeys(newbie, keyarr.ka32, keyBits);
 /* EXPORT DELETE END */
 }
 
+
+/*
+ * Encrypt one block using AES.
+ * Align if needed and (for x86 32-bit only) byte-swap.
+ *
+ * Parameters:
+ * ks	Key schedule, of type aes_key_t
+ * pt	Input block (plain text)
+ * ct	Output block (crypto text).  Can overlap with pt
+ */
 void
-aes_encrypt_block(void *ks, uint8_t *pt, uint8_t *ct)
+aes_encrypt_block(const void *ks, const uint8_t *pt, uint8_t *ct)
 {
 /* EXPORT DELETE START */
+	aes_key_t	*ksch = (aes_key_t *)ks;
 
-	aes_key_t *ksch = (aes_key_t *)ks;
-
-#ifdef _BIG_ENDIAN
-	if (IS_P2ALIGNED(pt, sizeof (uint32_t)) &&
-	    IS_P2ALIGNED(ct, sizeof (uint32_t))) {
-		/* LINTED:  pointer alignment */
-		aes_encrypt_impl(&ksch->encr_ks, ksch->nr, (uint32_t *)pt,
+#ifndef	AES_BYTE_SWAP
+	if (IS_P2ALIGNED2(pt, ct, sizeof (uint32_t))) {
+		AES_ENCRYPT_IMPL(&ksch->encr_ks.ks32[0], ksch->nr,
 		    /* LINTED:  pointer alignment */
-		    (uint32_t *)ct);
+		    (uint32_t *)pt, (uint32_t *)ct);
 	} else {
 #endif
 		uint32_t buffer[AES_BLOCK_LEN / sizeof (uint32_t)];
 
+		/* Copy input block into buffer */
+#ifndef	AES_BYTE_SWAP
+		bcopy(pt, &buffer, AES_BLOCK_LEN);
+
+#else	/* byte swap */
 		buffer[0] = (((uint32_t)pt[0] << 24) | ((uint32_t)pt[1] << 16) |
 		    ((uint32_t)pt[2] << 8) | (uint32_t)pt[3]);
-
 		buffer[1] = (((uint32_t)pt[4] << 24) | ((uint32_t)pt[5] << 16) |
 		    ((uint32_t)pt[6] << 8) | (uint32_t)pt[7]);
-
 		buffer[2] = (((uint32_t)pt[8] << 24) | ((uint32_t)pt[9] << 16) |
 		    ((uint32_t)pt[10] << 8) | (uint32_t)pt[11]);
-
 		buffer[3] = (((uint32_t)pt[12] << 24) |
 		    ((uint32_t)pt[13] << 16) | ((uint32_t)pt[14] << 8) |
 		    (uint32_t)pt[15]);
+#endif
 
-		aes_encrypt_impl(&ksch->encr_ks, ksch->nr, buffer, buffer);
+		AES_ENCRYPT_IMPL(&ksch->encr_ks.ks32[0], ksch->nr,
+		    buffer, buffer);
 
+		/* Copy result from buffer to output block */
+#ifndef	AES_BYTE_SWAP
+		bcopy(&buffer, ct, AES_BLOCK_LEN);
+	}
+
+#else	/* byte swap */
 		ct[0] = buffer[0] >> 24;
 		ct[1] = buffer[0] >> 16;
 		ct[2] = buffer[0] >> 8;
@@ -1473,31 +1565,40 @@
 		ct[13] = buffer[3] >> 16;
 		ct[14] = buffer[3] >> 8;
 		ct[15] = (uint8_t)buffer[3];
-#ifdef _BIG_ENDIAN
-	}
 #endif
-
 /* EXPORT DELETE END */
 }
 
+
+/*
+ * Decrypt one block using AES.
+ * Align and byte-swap if needed.
+ *
+ * Parameters:
+ * ks	Key schedule, of type aes_key_t
+ * ct	Input block (crypto text)
+ * pt	Output block (plain text). Can overlap with pt
+ */
 void
-aes_decrypt_block(void *ks, uint8_t *ct, uint8_t *pt)
+aes_decrypt_block(const void *ks, const uint8_t *ct, uint8_t *pt)
 {
 /* EXPORT DELETE START */
+	aes_key_t	*ksch = (aes_key_t *)ks;
 
-	aes_key_t *ksch = (aes_key_t *)ks;
-
-#ifdef _BIG_ENDIAN
-	if (IS_P2ALIGNED(ct, sizeof (uint32_t)) &&
-	    IS_P2ALIGNED(pt, sizeof (uint32_t))) {
-		/* LINTED:  pointer alignment */
-		aes_decrypt_impl(&ksch->decr_ks, ksch->nr, (uint32_t *)ct,
+#ifndef	AES_BYTE_SWAP
+	if (IS_P2ALIGNED2(ct, pt, sizeof (uint32_t))) {
+		AES_DECRYPT_IMPL(&ksch->decr_ks.ks32[0], ksch->nr,
 		    /* LINTED:  pointer alignment */
-		    (uint32_t *)pt);
+		    (uint32_t *)ct, (uint32_t *)pt);
 	} else {
 #endif
 		uint32_t buffer[AES_BLOCK_LEN / sizeof (uint32_t)];
 
+		/* Copy input block into buffer */
+#ifndef	AES_BYTE_SWAP
+		bcopy(ct, &buffer, AES_BLOCK_LEN);
+
+#else	/* byte swap */
 		buffer[0] = (((uint32_t)ct[0] << 24) | ((uint32_t)ct[1] << 16) |
 		    ((uint32_t)ct[2] << 8) | (uint32_t)ct[3]);
 
@@ -1510,9 +1611,17 @@
 		buffer[3] = (((uint32_t)ct[12] << 24) |
 		    ((uint32_t)ct[13] << 16) | ((uint32_t)ct[14] << 8) |
 		    (uint32_t)ct[15]);
+#endif
 
-		aes_decrypt_impl(&ksch->decr_ks, ksch->nr, buffer, buffer);
+		AES_DECRYPT_IMPL(&ksch->decr_ks.ks32[0], ksch->nr,
+		    buffer, buffer);
 
+		/* Copy result from buffer to output block */
+#ifndef	AES_BYTE_SWAP
+		bcopy(&buffer, pt, AES_BLOCK_LEN);
+	}
+
+#else	/* byte swap */
 		pt[0] = buffer[0] >> 24;
 		pt[1] = buffer[0] >> 16;
 		pt[2] = buffer[0] >> 8;
@@ -1529,26 +1638,30 @@
 		pt[13] = buffer[3] >> 16;
 		pt[14] = buffer[3] >> 8;
 		pt[15] = (uint8_t)buffer[3];
-#ifdef _BIG_ENDIAN
-	}
 #endif
 
 /* EXPORT DELETE END */
 }
 
+
 /*
- * Allocate key schedule for AES
+ * Allocate key schedule for AES.
+ *
+ * Return the pointer and set size to the number of bytes allocated.
+ * Memory allocated must be freed by the caller when done.
+ *
+ * Parameters:
+ * size		Size of key schedule allocated, in bytes
+ * kmflag	Flag passed to kmem_alloc(9F); ignored in userland.
  */
 /* ARGSUSED */
 void *
 aes_alloc_keysched(size_t *size, int kmflag)
 {
-
 /* EXPORT DELETE START */
-
 	aes_key_t *keysched;
 
-#ifdef 	_KERNEL
+#ifdef	_KERNEL
 	keysched = (aes_key_t *)kmem_alloc(sizeof (aes_key_t), kmflag);
 #else	/* !_KERNEL */
 	keysched = (aes_key_t *)malloc(sizeof (aes_key_t));
@@ -1558,8 +1671,6 @@
 		*size = sizeof (aes_key_t);
 		return (keysched);
 	}
-
 /* EXPORT DELETE END */
-
 	return (NULL);
 }
